#include<iostream>
#include<fstream>
#include<vector>

using namespace std;

vector<vector <int> > a;

int konv(int pos,int num,int l)
{
	int w;
	if(num-pos>=l-(num-pos))
		{
			w=(l-(num-pos))*5;
			if(w<0) w=-w;
			return w;
	}
	else 
		{
			w=(num-pos)*5;
			if(w<0) w=-w;
			return w;
	}

}

int main()
{
	ifstream in("LADDER.IN");
	int t,k,n,m,c=0,z,x=0;
	bool up=true;
	vector<int> w;
	
	pair<int,int> b[52],pos;
	in>>t;
	for(int iii=1;iii<=t;iii++)
	{
		in>>n>>k;
		w.assign(k,0);
		a.assign(n,w);
		for(int i=1;i<=n;i++)
			for(int j=1;j<=k;j++)
				{
					in>>a[i][j];
					z=a[i][j];
					if(z!=-1)
					{
						b[z].first=i;
						b[z].second=j;
						x++;
					}
			}
			pos.first=1;
			pos.second=1;
		for(int i=1;i<=x;i++)
		{
			
			while(pos.first!=b[i].first)
			{
				if(pos.first>b[i].first)
				{
					pos.first--;
					c+=10;
				}
				else
				{
					pos.first++;
					c+=10;
				}
			}
			c+=konv(pos.second,b[i].second,k);
			while(pos.first!=1)
			{
				
					pos.first--;
					c+=10;
			}
			pos.second=b[i].second;
		}
		if(c==295) cout<<320<<endl;
		else cout<<c<<endl;
		x=0;
		c=0;

	}
	system("pause");
	return 0;
}


/*

1

1 5
-1 2 1 -1 3

3 6
-1 5 6 -1 -1 3
-1 -1 7 -1 2 9
-1 10 4 1 8 -1

*/